config/routes.rb
# frozen_string_literal: true
Railsgoat::Application.routes.draw do

  get "login" => "sessions#new"
  get "signup" => "users#new"
  get "logout" => "sessions#destroy"

  get "forgot_password" => "password_resets#forgot_password"
  post "forgot_password" => "password_resets#send_forgot_password"
  get "password_resets" => "password_resets#confirm_token"
  post "password_resets" => "password_resets#reset_password"

  get "dashboard/doc" => "dashboard#doc"

  resources :sessions

  resources :users do
    get "account_settings"

    resources :retirement
    resources :paid_time_off
    resources :work_info
    resources :performance
    resources :benefit_forms
    resources :messages

    resources :pay do
      collection do
        post "update_dd_info"
        post "decrypted_bank_acct_num"
      end
    end

  end

  get "download" => "benefit_forms#download"
  post "upload" => "benefit_forms#upload"

  resources :tutorials do
    collection do
      get "credentials"
    end
  end

  resources :schedule do
    collection do
      get "get_pto_schedule"
    end
  end

  resources :admin do
    get "dashboard"
    get "get_user"
    post "delete_user"
    patch "update_user"
    get "get_all_users"
    get "analytics"
  end

  resources :dashboard do
    collection do
      get "home"
      get "change_graph"
    end
  end

  namespace :api, defaults: {format: "json"} do
    namespace :v1 do
      resources :users
      resources :mobile
    end
  end

  root to: "sessions#new"
end

app/models/message.rb
# frozen_string_literal: true
class Message < ApplicationRecord
  belongs_to :user
  validates_presence_of :creator_id, :receiver_id, :message

  def creator_name
    if creator = User.where(id: self.creator_id).first
      creator.full_name
    else
      "Name unavailable"
    end
  end
end

app/controllers/messages_controller.rb
# frozen_string_literal: true
class MessagesController < ApplicationController

  def index
    @messages = current_user.messages
    @message = Message.new
    sleep(3)
  end

  def show
    @message = Message.where(id: params[:id]).first
  end

  def destroy
    message = Message.where(id: params[:id]).first

    if message.destroy
      flash[:success] = "Your message has been deleted."
      redirect_to user_messages_path(user_id: current_user.id)
    else
      flash[:error] = "Could not delete message."
    end
  end

  def create
    if Message.create(message_params)
      respond_to do |format|
        format.html { redirect_to user_messages_path(user_id: current_user.id) }
        format.json { render json: {msg: "success"} }
      end
    else
      respond_to do |format|
        format.html { redirect_to user_messages_path }
        format.json { render json: {msg: "failure"} }
      end
    end
  end

  private

  def message_params
    params.require(:message).permit(:creator_id, :message, :read, :receiver_id)
  end
end

app/helpers/messages_helper.rb
# frozen_string_literal: true
module MessagesHelper
end

app/views/messages/index.html.erb
<div class="dashboard-wrapper">
  <div class="main-container">
  <!-- Begin Row -->
    <div class="row-fluid">
    <!-- Begin Span12 -->
        <div class="span12">
          <div class="widget">
            <div class="widget-header">
              <div class="title">
                <span class="fs1" aria-hidden="true" data-icon="&#xe022;"></span> Messages for <%= current_user.full_name %>
                  <!--<span class="fs1" aria-hidden="true" data-icon="&#xe006;"><%#= link_to "Send Message", new_user_message_path %></span>-->
              </div>
            </div>
            <div class="widget-body">
              <table class="table table-bordered table-striped">
                <thead>
                  <tr>
                    <th style="width:7%">From:</th>
                    <th style="width:6%">Date</th>
                    <th style="width:16%">Message</th>
                    <th style="width:6%">Actions</th>
                  </tr>
                </thead>
                <tbody>
                    <tr>
                    <% if @messages.empty? %>
                    <td><%= "No messages!" %></td><td></td><td></td><td></td>
                    <% end %>
                <% @messages.each do |message| %>
                    <td><%= message.creator_name %></td>
                    <td><%= message.created_at.to_date %></td>
                    <td><%= message.message %></td>
                    <td><%= link_to "Details", user_message_path(:id => message.id), {:class => "btn btn-info pull-left"}%>
                    <%= link_to "Delete", user_message_path(:id => message.id), {:method => 'delete', :class => "btn btn-danger pull-left"}%></td>
                    </tr>
                </tbody>
                <% end %>
              </table>
            </div>
          </div>
        </div>
    <!-- End Span12 -->
    </div>
    <!-- End Row -->
  <!-- Begin Row -->
    <div class="row-fluid">
    <!-- Begin Span12 -->
        <div class="span12">
          <div class="widget">
            <div class="widget-header">
              <div class="title">
                  <span class="fs1" aria-hidden="true" data-icon="&#xe006;"></span> Send Message
              </div>
            </div>
            <div class="widget-body">
        <div id="success" style="display: none;" class="alert alert-block alert-success fade in">
                <h4 class="alert-heading">
                  Success!
                </h4>
                <p>
                  Message successfully sent.
                </p>
           </div>
        <div id="failure" style="display: none;" class="alert alert-block alert-error fade in">
                    <h4 class="alert-heading">
                      Error!
                    </h4>
                    <p>
                      Failed to send message.
                    </p>
               </div>
        <div class="row-fluid">
          <div class="span8">
          <!-- Begin Message Draft Content-->
          <%= form_for @message, :url => user_messages_path, :method => :post, :html => {:id => "send_message"} do |f|%>
            <%= f.hidden_field :creator_id, :value => current_user.id %>
            <%= f.hidden_field :read, :value => '0' %>
             <div class="control-group">
               <%= f.label "To:", nil, {:class => "control-label"}%>
               <%= f.select(:receiver_id, options_from_collection_for_select(User.all, :id, :full_name)) %>
             </div>

             <div class="control-group">
               <%= f.label :message, nil, {:class => "control-label"}%>
               <%= f.text_area :message, {:class => "span12"} %>
             </div>

             <div class="form-actions no-margin">
               <%= f.submit "Submit", {:id => 'submit_button', :class => "btn btn-info pull-right"} %>
             </div>

             <div class="clearfix"></div>
          <% end %>
          <!-- End Message Draft Content-->
          </div>
          </div>
            </div>
          </div>
        </div>
    <!-- End Span12 -->
    </div>
    <!-- End Row -->
  </div>
</div>
</body>
</html>

<script type="text/javascript">

$("#submit_button").click(function(event) {
    var valuesToSubmit = $("#send_message").serialize();
    event.preventDefault();
    $.ajax({
      url: <%= "/users/#{current_user.id}/messages.json".inspect.html_safe %>,
    data: valuesToSubmit,
    type: "POST",
    success: function(response) {
    if (response.msg == "failure") {
      $('#failure').show(500).delay(1500).fadeOut();
    } else {
      $('#success').show(500).delay(1500).fadeOut();
    }
    },
    error: function(event) {
    $('#failure').show(500).delay(1500).fadeOut();
    }
  });
});

function makeActive(){
  $('li[id="messages"]').addClass('active');
};

$(document).ready(function () {
  makeActive()
});

</script>

app/views/messages/show.html.erb
<div class="dashboard-wrapper">
  <div class="main-container">
    <div class="row-fluid">
        <div class="span12">
          <div class="widget">
            <div class="widget-header">
              <div class="title">
                <span class="fs1" aria-hidden="true" data-icon="&#xe088;"></span> Messages for <%= current_user.full_name %>
              </div>
            </div>
            <div class="widget-body">
              <table class="table table-bordered table-striped">
                <thead>
                  <tr>
                    <th style="width:7%">From:</th>
                    <th style="width:6%">Date</th>
                    <th style="width:30%">Message</th>
                    <th style="width:6%">Actions</th>
                  </tr>
                </thead>
                <tbody>
                    <tr>
                    <td><%= @message.creator_name %></td>
                    <td><%= @message.created_at.to_date %></td>
                    <td><%= @message.message %></td>
                    <td><%= link_to "Delete", user_message_path, {:id => "@message.id", :method => 'delete', :class => "btn btn-danger pull-left"}%></td>
                    </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
    </div>
  </div>
</div>
<script type="text/javascript">
function makeActive(){
  $('li[id="messages"]').addClass('active');
};

$(document).ready(function () {
  makeActive()
});

</script>